import sys, subprocess, time

class SAYL_PARAMS:
	def __init__(self, fold, subfold, threshold, minpos, searchMode, score):
		self.fold = fold
		self.subfold = subfold
		self.threshold = threshold
		self.minpos = minpos
		self.searchMode = searchMode
		self.score = score

def buildSettings():
	settings = list()
	for f in range(NUM_FOLDS):
		for sf in range(NUM_SUB_FOLDS):
			for t in THRESHOLDS:
				for mp in MINPOS:
					for sm in SEARCH_MODES:
						for s in SCORING_METHODS:
							settings.append(SAYL_PARAMS(f + 1, sf + 1, t, mp, sm, s))
	return settings

def main(args):
	print('Building settings...')
	settings = buildSettings();
	print('Starting jobs...')
	# run them in batches of MAX_JOBS
	startJob = 0
	while startJob < len(settings):
		endJob = min(startJob + MAX_JOBS, len(settings))
		# run through the batch
		for job in range(startJob, endJob):
			# do a single job
			print('Running job ' + str(job))
			s = settings[job]
			fmt = './run_diff_sayu_internal_cv_setting.sh {0} {1} {2} {3} {4} {5} &'
			callStr = fmt.format(s.fold, s.subfold, s.threshold, s.minpos, s.searchMode, s.score)
			subprocess.call(callStr, shell=True)
		# wait for this batch to finish and make sure yap dies
		startTime = time.time()
		terminateTime = startTime + MAX_TIME
		currentTime = startTime
		# while we aren't done, sleep for a bit (yes, spin wait)
		while currentTime < terminateTime:
			time.sleep(120)
			currentTime = time.time()
		# we're done, so kill any yap jobs still running
		print('Batch done, killing yap...')
		subprocess.call('killall yap', shell=True)
		# on to the next batch then...
		startJob += MAX_JOBS

NUM_FOLDS = 10
NUM_SUB_FOLDS = NUM_FOLDS - 1
THRESHOLDS = [1.01] #[1.01, 1.05, 1.10]
MINPOS = [6, 12]
SEARCH_MODES = ['em'] #['eager', 'em']
SCORING_METHODS = [2]
MAX_JOBS = 8 # max number of jobs to run at once
MAX_TIME = 60 * 65 # max time to run a batch in seconds

main(sys.argv)