
/*



      @param trainSet 
      @param useAggs  1 == use aggs, else use just prob features
      @param trainPos the number of positive examples in the train set.
      @param trainNeg the number of negative examples in the train set.
      @param testPos the number of positive examples in the test set.
      @param testNeg the number of negative examples in the test set.
      @param pseudo the psuedo count to use when constructing the
      condition probabiliy distribution.
      @param scoreFunction the metric to use for scoring the classifier.
There are 4 metrics implemented. Accuracy, Conditionally Log Likelihood,
Area uner the ROC curve, and Area under a Precision Recall Curve.
      @param classifierType what type of classifier to use to guide the
      search
            @return the score of the default classifier according to
	    <scoreFunction>
	          public static double init(int[] dataSets, int useAgg, int trainPos,
					    int trainNeg, int tunePos, int tuneNeg, int testPos, int testNeg, int
					   pseudo, int scoreFunction, int classifierType){
											
    public static final int TRAIN_SET = 0;
    public static final int TUNE_SET = 1;
    public static final int TEST_SET = 2;

    public static final int ACC = 0;
    public static final int PR_AREA = 1;
    public static final int ROC_AREA = 2;
    public static final int CLL = 3;

    public static final int NB = 0;
    public static final int TAN = 1;
    public static final int VOTE = 2;

    public static final int NO_EDGE = 0;
    public static final int OUT_EDGE = 1;
    public static final int IN_EDGE = 2;


}*/

% dump_file for final probability listing.


:- use_module(common/utils,
	      [average/2]).

:- use_module(common/set,
	      [vsc_set/1]).

:- use_module(common/debug_write,
	      [debug_format/3]).

:- use_module(scorer/scorer,
	      [scorer_init/0,
	       new_feature/5,
	       commit_update/1,
	       covers_example/4,
	       init_scoring/1,
	       better_score/2,
	       vals_to_scorable/3,
	       get_probs/2,
	       current_score/1,
	       scoring_data/4,
	       scorer_exit/0,
	       current_test_score/1
	      ]
	     ).		  

:- dynamic sayu_dump_file/1.


:- dynamic sayu_mode/1.
:- dynamic sayu_cur_best/6.

:- dynamic sayu_min_cov/1.
:- dynamic sayu_min_pos/1.

:- dynamic sayu_start_seeds/1.

:- dynamic sayu_scoring_method/1.

:- dynamic sayu_init_theory/1.

:- dynamic sayu_output_theory/1.

% folds
% first arg is train set
% third argument is test set
:- vsc_set(sayu_folds([],[],[],[])).

:- dynamic pict_mode/1.

:- dynamic sayu_prefix/1.

:- dynamic sayu_accept_clause/1, sayu_accept_delta/1.

:- dynamic pathf/1.

:- dynamic program/1.

program(sayu).

/*

whichData == 0 -> return train set score
whichData == 1 -> return tune set score
whichData == 2 -> return test set score
public static double getScore(int whichData, int scoreFunction){

testData > 0 -> update prob estimates about the test set
    public static void commit(void){

public static double newattribute(byte[] posVector, byte[] negVector, 
byte[] testPosVector, byte[] testNegVector, int scoreFunction){


public static double init(int numPos, int numNeg, int testPos, int 
testNeg, int psuedo, int scoreFunction){

*/

% changed from a minimum of 10
:- vsc_set(sayu_min_cov(1)).
:- vsc_set(sayu_max_clauses(100)).
:- vsc_set(sayu_max_seeds(2000)).

sayu_init_theory(none).

sayu_output_theory('theory.yap').

%
% initialise search
%
sayu_start_seeds(20).

sayu_mode(eager).

% first hack at top-level.
induce_sayu(bf) :-
	statistics(runtime,[T,_]),
	assert(sayu_initial_runtime(T)),
	set(evalfn,bayes_net),
	scorer_init,
	retractall(sayu_n_of_nodes(_)),
	assert(sayu_n_of_nodes(0)),
	open(learning_curve,write,S),
	recorda(learning_curve,S,_),
%	sayu_min_cov(MinCov),
%	set(minpos,MinCov),
%	set(minpos,5),
	set(minacc,0.0001),
	set(explore,true),
%	set(search,heuristic),
%	N is TrNSize+TuNSize+1,
%	set(noise,N),
%	from(Cl,2,10),
%	set(clauselength,Cl),
%	from(I,1,PSize),
	assert(n_of_seeds(100)),
%	set(clauselength,2),
%	vsc_set(sayu_min_recall_in_area(0.5)),
%	sayu_min_cov(MinCov),
%	InitSeedSize is TrPSize/4,
%	vsc_set(sayu_start_seeds(InitSeedSize)),
%	vsc_set(sayu_min_cov(30)),
%	sayu_seed(TrPSize),
%	vsc_set(sayu_min_cov(MinCov)),
%	vsc_set(sayu_mode(eager)),
%	set(nodes,10000),
	(
	   pict_mode(on) ->
	   pict_init(rsd, 2, 1)
	;
	   true
	),
	sayu_load_default,
	repeat,
	sayu_pick_seed(Seed),
	catch(do_next_seed(Seed),found_one,true).

sayu_pick_seed(Seed) :-
%	sayu_n_of_nodes(0), !,
%	recorded(aleph,atoms(pos,[1-TrPSize]),_),
	user:sayu_strata(NTrain0f,_NTune0f,_NTest0f,_NTrain0n,_NTune0n,_NTest0n),
	Seed is 1 + integer(random*NTrain0f).
%	Seed is 1 + integer(random*TrPSize).
sayu_pick_seed(Seed) :- fail,
	current_predicate(_,test_neg:P), !,
	get_probs(0, AllProbs),
	findall(P,train_neg:P,LN),
	sayu_skip_probs(LN,AllProbs,PProbs),
	sayu_add_probs(PProbs,0,Tot,Sums),
	Key is random*Tot,
	sayu_fetch_ex(Key,Sums,1,Seed).

sayu_skip_probs([],Probs,Probs).
sayu_skip_probs([_|LN],[_|Probs],PProbs) :-
	sayu_skip_probs(LN,Probs,PProbs).

sayu_add_probs([],Tot,Tot,[]).
sayu_add_probs([PROB|PProbs],S0,Tot,[S|Ss]) :-
	S is S0+PROB,
	sayu_add_probs(PProbs,S,Tot,Ss).

sayu_fetch_ex(Key,[Sum|_],Seed,Seed) :- Key < Sum, !.
sayu_fetch_ex(Key,[_|Sums],I0,Seed) :-
	I is I0+1,
	sayu_fetch_ex(Key,Sums,I,Seed).

sayu_seed(TrPSize) :-
	sayu_start_seeds(Seeds),
	for(_,1,Seeds),
	sayu_seed_net(TrPSize),
	fail.
sayu_seed(_).
	

sayu_seed_net(TrPSize) :-
	Seed is 1 + integer(random*TrPSize),
	assert(sayu_mode(em)),
	setting(nodes,Nodes),
	set(nodes,1000),
	do_next_seed(Seed),
	set(nodes,Nodes).


do_next_seed(I) :-
	retractall(current_seed(_)),
	assert(current_seed(I)),
	sat(I),
	reduce,
	sayu_add_best_clause.

induce_sayu :-
	induce_sayu(bf).

induce_sayu_timed(T) :-
	alarm(T,scorer_exit,_),
	induce_sayu,
	fail.
induce_sayu_timed(_) :-
	scorer_exit.


sayu_load_default :-
	sayu_init_theory(none), !.
sayu_load_default :-
	sayu_init_theory(F),
	compile(sayu_init_theory:F),
	fail.
sayu_load_default :-
	example(1,pos,Ex),
	functor(Ex, Na, Ar),
	functor(Head,Na,Ar),
	set_value(sayu_clauses,0),
	clause(sayu_init_theory:Head, Body),
	sayu_add_user_clause( (Head :- Body) ),
	fail.
sayu_load_default.

sayu_add_user_clause(RCl) :-
	get_value(sayu_clauses,NCls),
	NCls1 is NCls+1,
	set_value(sayu_clauses,NCls1),
	retractall(current_seed(_)),
	assert(current_seed(0)),
	scoring_data(TrPos,TrNeg,TePos,TeNeg),
	init_scoring(TrPos),
	init_scoring(TrNeg),
        sayu_run_examples(TrPos, RCl, pos, TP),
        sayu_run_examples(TrNeg, RCl, neg, TN),
	new_feature(TrPos,TrNeg,TePos,TeNeg, Likelihoods),
	retractall(sayu_old_best(_)),
	assert(sayu_old_best(Likelihoods)),
	recorda(sayu_score,sc(Likelihoods,TP,TN,TrPos,TrNeg),_),
	catch(execute_sayu_add_clause(Likelihoods, RCl, TP, TN, TrPos, TrNeg), found_one, fail).

sayu_run_examples(Array, (Ex :- Bd), Type, Total) :-
        S = sum(0),
	(
          example(I, Type, Ex),
	  once(Bd),
	  S = sum(I0),
	  I is I0+1,
	  nb_setarg(1, S, I),
	  covers_example(Array, Type, train, I),
	  fail
	;
	  S = sum(Total)
	).


/*
:- dynamic bitmap/2.

% called before evalfn from get_gain1
sayu_check_cover(PCvr,NCvr) :-
	findall((Pos-Neg),bitmap(Pos,Neg),[_,B2,B3]), !,
	dump_bitmaps(B2,B3),
	halt.
*/
:- set_value(sayu_clauses,0).

sayu_check_cover(_,_,(_ :- true)) :- !,
        current_score(Lik),
	recorda(sayu_score,sc(Lik,0,0,0,0),_).
sayu_check_cover(PCvr,NCvr,_RCl) :-
	get_value(sayu_clauses,NCls),
	NCls1 is NCls+1,
	set_value(sayu_clauses,NCls1),
	scoring_data(TrPos,TrNeg,TePos,TeNeg),
	init_scoring(TrPos),
	init_scoring(TrNeg),
        sayu_store_intervals(PCvr,pos,0,TotPos,TrPos),
        sayu_store_intervals(NCvr,neg,0,TotNeg,TrNeg),
	new_feature(TrPos,TrNeg,TePos,TeNeg, Likelihoods),
	recorda(sayu_score,sc(Likelihoods,TotPos,TotNeg,TrPos,TrNeg),_).

% called by evalfn
sayu_score(Eval, Clause) :-
	current_score(CurLik),
	recorded(sayu_score,sc(Scores,TP,TN,TrPos,TrNeg),R),
	erase(R),
	sayu_add_clause(Scores, CurLik, Clause,TP,TN,TrPos,TrNeg),
%	write(Scores),nl,
	average(Scores, Eval).


sayu_store_intervals([],_,TotPos,TotPos,_).
sayu_store_intervals(Ints/Lazies,PosNeg,TotPos0,TotPosF, Tr) :-
	sayu_store_intervals(Ints,PosNeg,TotPos0,TotPosI, Tr),
	sayu_store_intervals(Lazies,PosNeg,TotPosI,TotPosF, Tr).
sayu_store_intervals([Intv|PCvr],PosNeg,TotPos0,TotPosF, Tr) :-
	sayu_add_interval(Intv, PosNeg,TotPos0, TotPosI, Tr),
	sayu_store_intervals(PCvr,PosNeg,TotPosI,TotPosF, Tr).

sayu_add_interval(X-X, PosNeg, TotPos0, TotPosF, Tr) :- !,
	sayu_add_ex(X, PosNeg, TotPos0, TotPosF, Tr).
sayu_add_interval(X-Y, PosNeg, TotPos0, TotPosF, Tr) :- !,
	sayu_add_ex(X, PosNeg, TotPos0, TotPosI, Tr),
	Next is X+1,
	sayu_add_interval(Next-Y, PosNeg, TotPosI, TotPosF, Tr).

% add to training set
sayu_add_ex(X, PosNeg, TotPos0, TotPosF, Tr) :-
	TotPosF is TotPos0+1,
	covers_example(Tr, PosNeg, train, X).

sayu_add_clause(Scores, CurLik, RCl, TP, TN, TrPos, TrNeg) :-
	( setting(minpos,MinPos) -> TP >= MinPos ; true),
	( sayu_min_cov(MinCov) -> TP+TN >= MinCov ; true),
	better_score(Scores, CurLik),
%	format(user_error,"Adding score ~w/~w (~d/~d)~n",[Score,CurLik,TP,TN]),
	(RCl = (_ :- _)),
	\+ recorded(sayu_theory,RCl,_), !,
	do_sayu_add_clause(Scores,RCl,TP,TN,TrPos,TrNeg).
% sayu_add_clause(_, Cl, _, _, _, _, _, _, _) :-
% 	pict:check_pict_in_theory(Cl,I),
% %write(Cl,I),nl,
% 	pict_undo_invention(I), listing(invent), !.
sayu_add_clause(_, _, _, _, _, _, _).

do_sayu_add_clause(Scores,RCl,TP,TN,TrPos,TrNeg) :-
	sayu_mode(eager),
	!,
	execute_sayu_add_clause(Scores,RCl,TP,TN,TrPos,TrNeg).
do_sayu_add_clause(Scores,RCl,TP,TN,TrPos,TrNeg) :-
	sayu_mode(em),
	(sayu_cur_best(X,_,_,_,_,_) -> true ; sayu_old_best(X)),
	( better_score(Scores, X) ->
	    retractall(sayu_cur_best(_,_,_,_,_,_)),
	    format(user_error,'******** BEST ~w *************~n',[Scores]),
	    assert(sayu_cur_best(Scores,RCl,TP,TN,TrPos,TrNeg))
	;
	    true
	).

sayu_add_best_clause :-
	retract(sayu_cur_best(Scores,RCl,TP,TN,TrPos,TrNeg)),
	format(user_error,'ADDING',[]),
	assert(sayu_old_best(Scores)),
	RCl \= true, !,
	execute_sayu_add_clause(Scores,RCl,TP,TN,TrPos,TrNeg).
sayu_add_best_clause.

execute_sayu_add_clause(Scores,RCl,TP,TN,TrPos,TrNeg) :-
	flush_output,
	get_value(sayu_clauses,NCls),
	recordz(sayu_theory,RCl,_),
	retract(sayu_n_of_nodes(I0)),
	I is I0+1,
	current_score(OldLikelihood),
	debug_format(1,'~n[ add clause ~d (from ~d) to Bayes Network (~d/~d) ~w => ~w~n', [I0,NCls,TP,TN,OldLikelihood,Scores]),
	recordz(theory_clause,RCl,_),
	portray_clause(user_error,RCl),
	update_sayu_test(I,RCl,Scores,TrPos,TrNeg),
%	myjpl_call('sayu.NBayes', update, [], _),
	commit_update(Scores),
%	myjpl_call(Class, printCurve, [1,ScoringMethod], _),
%	myjpl_call(Class, printCurve, [2,ScoringMethod], _),
	current_seed(SeedNumber),
	current_test_score(TestLikelihood),
	statistics(runtime,[T,_]),
	sayu_initial_runtime(T0),
	DeltaT is (T-T0)/1000,
	debug_format(1,' Test Score (at seed ~d, ~3f sec) ~w. ]~n',[SeedNumber,DeltaT,TestLikelihood]),
	recorded(learning_curve,S,_),
	format(S,'liks(~d,~w,~w).~n',[I,Scores,TestLikelihood]),
	assert(sayu_n_of_nodes(I)),
	sayu_mode(eager),
	throw(found_one).

update_sayu_test(_I,RCl,_Scores,TrPos,TrNeg) :-
	sayu_gen_test_score(test_pos,RCl,PPos),
	vals_to_scorable(PPos, byte, TePos),
	sayu_gen_test_score(test_neg,RCl,PNeg),
	vals_to_scorable(PNeg, byte, TeNeg),
%	length(PNeg,Ps),
%	length(PNeg,Ns),
%	format('-> ~w+~w~n',[Ps,Ns]),
%	myjpl_call('sayu.NBayes', test_new_attribute, [Pos,Neg], Likelihood),
	new_feature(TrPos,TrNeg,TePos,TeNeg, _).

sayu_gen_test_score(Mod,(H :- Bd),L) :-
	findall(Score,(Mod:H,sayu_do_goal(Bd,Score)),L).

sayu_do_goal(Bd,1) :-
	Bd, !.
sayu_do_goal(_,0).
	


/* debug function */
sayu_dump_bitmaps(P1-N1,P2-N2) :-
	open('BMAP1',write,S1),
	open('BMAP2',write,S2),
	sayu_do_exs(P1,P2,0'1,S1,S2),
	sayu_do_exs(N1,N2,0'0,S1,S2),
	close(S1),
	close(S2),
	halt.

sayu_do_exs([P1|P1s],[P2|P2s],C,S1,S2) :-
	V1 is P1+0'0,
	V2 is P2+0'0,
	format(S1,'~c,~c~n',[V1,C]),
	format(S2,'~c,~c,~c~n',[V1,V2,C]),
	sayu_do_exs(P1s,P2s,C,S1,S2).
sayu_do_exs([],[],_,_,_).

example(Id,train,PosNeg,Ex) :-
	example(Id,PosNeg,Ex).
example(Id,test,pos,Ex) :-
	select_clause(test_pos, Id, Ex).
example(Id,test,neg,Ex) :-
	select_clause(test_neg, Id, Ex).

select_clause(Mod, Id, Ex) :-
	once(current_predicate(_,Mod:Ex1)),
	findall(Ex1,Mod:Ex1,L),
	lists:nth(Id, L, Ex).

% strata computation size: we load the examples just tp find out
% how many there are
sayu_compute_strata0_sizes(IPREFIX) :-
	atom_concat(IPREFIX,'train0.f',Train0f),
	compile(train0f:Train0f),
	current_predicate(train0f:P/N),
	functor(Pred, P, N),
	predicate_property(train0f:Pred, number_of_clauses(NTrain0f)),
	abolish(train0f:P/N),
	atom_concat(IPREFIX,'tune0.f',Tune0f),
	compile(tune0f:Tune0f),
	predicate_property(tune0f:Pred, number_of_clauses(NTune0f)),
	abolish(tune0f:P/N),
	atom_concat(IPREFIX,'test0.f',Test0f),
	compile(test0f:Test0f),
	predicate_property(test0f:Pred, number_of_clauses(NTest0f)),
	abolish(test0f:P/N),
	atom_concat(IPREFIX,'train0.n',Train0n),
	compile(train0n:Train0n),
	predicate_property(train0n:Pred, number_of_clauses(NTrain0n)),
	abolish(train0n:P/N),
	atom_concat(IPREFIX,'tune0.n',Tune0n),
	compile(tune0n:Tune0n),
	predicate_property(tune0n:Pred, number_of_clauses(NTune0n)),
	abolish(tune0n:P/N),
	atom_concat(IPREFIX,'test0.n',Test0n),
	compile(test0n:Test0n),
	predicate_property(test0n:Pred, number_of_clauses(NTest0n)),
	abolish(test0n:P/N),
	asserta(user:sayu_strata(NTrain0f,NTune0f,NTest0f,NTrain0n,NTune0n,NTest0n)).

% ignore VISTA's linkage declarations.
linkage(_,_,_).

build_hierarchy(_).

