package sayu;

/*
  Jesse Davis
  (c) April/May 2001
  CS 373

  Modified in 12/02 and 2/03

  this class holds the information that defines attributes.  


 */
public class Datapairs implements Attribute{

    private String attributeName; //name of the attribute

    /*
      the type of the attribute: i.e. discrete, continuous
     */
    private String attribType;
    private boolean discrete; //whether the attribute value is discrete
    //or continuous
    private int numValues;    //the number of possible values the attribute
    //can have

    private String[] attribVals; //holds the possible values for the attribute
    private boolean full; //whether attribVals contains all possible value
    // for the atribute

    //if the continuous
    private double avg = 0;

    private int numBins = 3;
    private double upper;
    private double lower;
    private double[] binBreaks = new double[numBins];

    private boolean binary;
    private double splitPoint;
    private boolean isContinuous = false;

    public String getBase(){
        return attributeName + " " + attribType;
    }

    //hack
    private int position;
    /*
      constructs an Datapairs.  assigns a to attributeName, d to discrete
      and vals to numValues.  constructs and initializes the array attribVals
      to null for each position
     */
    public Datapairs(String name, int numVals, String type){
        attributeName = name;
        //discrete = dis;
        numValues = numVals;
        attribVals = new String[numVals];
        for(int i= 0; i<numVals; i++)
            attribVals[i]=null;
        full = false;
        attribType = type;
        if (attribType.equals("continuous")){
            isContinuous = true;
        }
        if (isContinuous()){
            numValues = 3;
        }

        //if (attribType.equals("continuous"))
        //this.setAverage();
    }


    //returns the attribute name
    public String getName(){
        return attributeName;
    }

    /*
      returns whether the value of is discrete or continuous
      true corresponds to discrete
      false corresponds to continuous
     */
    public String getType(){
        return attribType;
    }

    /**
       returns the number of possible values an attribute could have
       note if this is a continuous feature, only two values are stored. the 
       values stored are upper and lower bounds for the possible values.  
     */
    public int getNumValues(){
        return numValues;
    }

    /*
      pre:  value is a possible value for this attribute
      post: if value is already in attribVals, nothing is done.
            otherwise value is insert into the first open slot of attribVals
     */
    /*
      pre:  value is a possible value for this attribute
      post: if value is already in attribVals, nothing is done.
            otherwise value is insert into the first open slot of attribVals
     */
    public void insertAttribVal(String value){
        boolean done = false;
        int pos = 0;
        //if the list isn't full and if value hasn't been inserted
        while ((!full) && (!done) && (pos<attribVals.length)){
            if (attribVals[pos] == null) {
                attribVals[pos] = value;
                done = true;
                //check to see attribVals contains a value in each position
                if (pos == (attribVals.length -1))
                    full = true;
            }
            //if value is already in attribVals break out of the loop
            else if (attribVals[pos].equals(value))
                done = true;
            pos++;
        }

    }

    /*
      pre:  0<= pos < attribVals
      post: returns the value at pos.  if pos doesn't satisfy the precondition
            returns null
     */
    public String getAttribValue(int pos){
        if ((pos < attribVals.length) && (pos >= 0))
            return attribVals[pos];
        else
            return null;
    }

    /*
       pre:  value is contained in the attribVals
       post: returns the index of value, if value is in the array
             otherwise returns -1
     */
    public int posAttribValue(String value){
        int i = 0;

        boolean done = false;
        while ((!done) && (i < attribVals.length)){
            if (attribVals[i].equals(value))
                done = true;
            else
                i++;
        }
        if (done)
            return i;
        else
            return -1;
    }//end of method posAttribValue

    /*
      returns a string representation of the triple if the form
      attributeName continous/discrete numvalues
     */
    public String toString(){
        String s = new String(attributeName);
        s = s.concat(" " + attribType + " has ");
        Integer i = new Integer(numValues);
        if (attribType.equals("continuous")){
            s = s.concat("values from ");
            for(int j = 0; j<numValues; j++)
                s = s.concat(attribVals[j] + " to ");

        }
        else{
            s = s.concat(i.toString() + " values: ");     
            for(int j = 0; j<numValues; j++)
                s = s.concat(attribVals[j] + " ");
        }

        return s;
    }

    /**
       @param format - how to format the continuous values
              0 - no information 
              1 - range
              2 - split point
       @return a String in the form for a names file

     */
    public String namesString(int format){
        String s = new String(attributeName);
        s = s + " " + attribType + " ";
        if (attribType.equals("continuous")){
            switch(format){
            case 0:
                break;	
            case 1:
                s = s + attribVals[0] + " " + attribVals[1];
                break;
            case 2:
                s = s + " split " + splitPoint;
                break;
            default:
            }


        }
        else{
            for(int j = 0; j < (numValues - 1); j++){
                s = s + attribVals[j] + " ";
            }
            s = s + attribVals[attribVals.length - 1];
        }
        return s;
    }

    /**
       checks to see if the value in check is valid.

       @return true if the value is 
                  a. in the range of acceptable values
		  b. one of possible values for discrete

     */
    public boolean contains (String check){
        if (attribType.equals("continuous")){
            if (attribVals.length > 0){ 
                double lower = Double.parseDouble(attribVals[0]);
                double upper = Double.parseDouble(attribVals[1]);
                double curVal = Double.parseDouble(check);
                return (((curVal >= lower) && (curVal <=upper))
                        || ((curVal <= lower) && (curVal >=upper)));
            }
            else 
                return false;
        }
        else{
            boolean done = false;
            for(int j = 0; j<numValues && !done; j++){
                if (attribVals[j].equals(check))
                    done = true;
            }
            return done;
        }
    }//end of method contains. 

    /*
      this was just a test method to make sure that that i was reading in the
      attribute values correctly.
      it just goes thru the attribVals and prints out the values
     */
    public void attribValPrint(){
        for(int i = 0; i<numValues; i++)
            System.out.print(attribVals[i] + " ");

    }//end of method attribValPrint()

    /**
         Pre Condition:  this only works and applies if the attribute is a 
                       continuous value attribute.

     */
    public void setAverage(){
        double d1 = Double.parseDouble(attribVals[0]);
        double d2 = Double.parseDouble(attribVals[1]);
        avg = (d1 + d2)/2;
    }//end of method setAverage

    /*
       Pre Condition:  this only works and applies if the attribute is a 
                       continuous value attribute.

     */
    public double getAverage(){
        return avg;
    }//end of method getAverage

    /**
       returns true if this a continuous attribute. false otherwise.
     */
    public boolean isContinuous(){
        return isContinuous;
        /*
	if (attribType.equals("continuous"))
	    return true;
	else
	    return false;
         */
    }//end of method isContinuous


    /**
       Pre Condition:  this only works and applies if the attribute is a 
                       continuous value attribute.

       this method only works if it is a continuous attribute
       returns the upper bound of the continuous values;
     */
    public double maxContinuous(){
        double max = Double.parseDouble(attribVals[0]);
        for(int ix = 1; ix < attribVals.length; ix++){
            if (max < Double.parseDouble(attribVals[ix])){
                max = Double.parseDouble(attribVals[ix]);
            }

        }

        return max;
    }//end of method maxContinuous

    /**
       Pre Condition:  this only works and applies if the attribute is a 
                       continuous value attribute.

       @return returns the difference in the boundsof the continuous attribute.

     */
    public double diff(){
        double max = Double.parseDouble(attribVals[0]);
        double min = Double.parseDouble(attribVals[0]);
        for(int ix = 1; ix < attribVals.length; ix++){
            if (max < Double.parseDouble(attribVals[ix])){
                max = Double.parseDouble(attribVals[ix]);
            }
            if (Double.parseDouble(attribVals[ix]) < min){
                min = Double.parseDouble(attribVals[ix]);
            }

        }

        upper = max;
        lower = min;

        return (max - min);


    }//end of method diff();


    public int getNumBins(){
        return numBins;
    }

    public double getMax(){
        return upper;
    }

    public double getMin(){
        return lower;
    }

    /**
       only applicable if the feature is continuous.  returns teh value 
       that splits the attribute into two discrete bins
     */
    public double getSplitPoint(){
        return splitPoint;
    }

    /**
       @param splitPt - is the splitpoint for making the feature discrete
     */
    public void setSplit(double splitPt){
        splitPoint = splitPt;
    }

    /**
       @return the array that contains the possible values for the 
               attribute
     */
    public String[] getAttribVals(){
        return attribVals;
    }

    public void insertValue(int pos, String val){
        attribVals[pos] = val;
    }

}//end of class datapairs










