package sayu;

import java.io.*;
import java.util.*;

public class Emulate{


    private int[][] cats;
    private int[][] trainInt;
    private int[][] tuneInt;
    private int[][] testInt;
    private int outputPosition;
    private int trainPos = 0;
    private int trainNeg = 0;
    private int tunePos = 0;
    private int tuneNeg = 0;
    private int testPos = 0;
    private int testNeg = 0;
    private VariableConsecInt[] attributes;
    private BNILPSearch sayu;// tan;
    private int option = -1;
    private int scoreFunction = Constants.PR_AREA;


    /**/
    public Emulate(String trainSet, String tuneSet, String testSet, int opt){
	trainInt = readDataFileInt(trainSet, ",");
	tuneInt = readDataFileInt(tuneSet, ",");
	testInt = readDataFileInt(testSet, ",");
	int[] max = new int[trainInt[0].length];
	int vid = 0;
	outputPosition = trainInt[0].length-1;
	attributes = new VariableConsecInt[max.length];
	
	for(int ix = 0; ix < trainInt[0].length; ix++){
	    max[ix] = trainInt[0][ix];

	    for(int jx = 1; jx < trainInt.length; jx++){
		if (max[ix] < trainInt[jx][ix]){
		    max[ix] = trainInt[jx][ix];
		}
	    }
	    for(int jx = 0; jx < tuneInt.length; jx++){
		if (max[ix] < tuneInt[jx][ix]){
		    max[ix] = tuneInt[jx][ix];
		}
	    }
	    for(int jx = 0; jx < testInt.length; jx++){
		if (max[ix] < testInt[jx][ix]){
		    max[ix] = testInt[jx][ix];
		}
	    }
	    String name = (ix == outputPosition) ? "Class" : "V" + vid;
	    //if (ix == outputPosition){
	    attributes[ix] = new VariableConsecInt("Class", max[ix]+1);
	}
	for(int ix = 0; ix < trainInt.length; ix++){
	    if (trainInt[ix][outputPosition] == 0){
		trainNeg++;
	    }
	    else{
		trainPos++;
	    }
	}
	for(int ix = 0; ix < tuneInt.length; ix++){
	    if (tuneInt[ix][outputPosition] == 0){
		tuneNeg++;
	    }
	    else{
		tunePos++;
	    }
	}
	for(int ix = 0; ix < testInt.length; ix++){
	    if (testInt[ix][outputPosition] == 0){
		testNeg++;
	    }
	    else{
		testPos++;
	    }
	}
	cats = new int[3][];
	cats[0] = new int[trainInt.length];
	cats[1] = new int[tuneInt.length];
	cats[2] = new int[testInt.length];
	for(int ix = 0; ix < trainInt.length; ix++){
	    byte cat = (ix >= trainPos) ? (byte)0 : (byte)1;
	    trainInt[ix][outputPosition] = cat;
	    cats[0][ix] = (int)cat;
	}

	for(int ix = 0; ix < tuneInt.length; ix++){
	    byte cat = (ix >= tunePos) ? (byte)0 : (byte)1;
	    tuneInt[ix][outputPosition] = cat;
	    cats[1][ix] = (int)cat;
	}
	for(int ix = 0; ix < testInt.length; ix++){
	    byte cat = (ix >= testPos) ? (byte)0 : (byte)1;
	    testInt[ix][outputPosition] = cat;
	    cats[2][ix] = cat;
	}
	this.option = opt;
    }

    public static void main(String[] args){
	Emulate emulate = new Emulate(args[0], args[1], args[2], Integer.parseInt(args[3]));
       
	//emulate.addAll();
	//emulate.addAllOld();
	//emulate.addRemoveTest();
	//emulate.addReplaceTest();
	//emulate.runSAYUAdd();
	emulate.testAllFunctions();
    }

    public void addRemoveTest(){
	if (option == 0){
	    System.out.println("NB");
	    sayu = new IncNB(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	}
	else if (option == 1){
	    System.out.println("TAN");
	    sayu = new IncTan(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	}
	else{
	    System.out.println("Invalid Option");
	    System.exit(-1);
	}
	
	//sayu = new FastTan(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	int[] valid = new int[outputPosition];
	int[] flipRate = new int[outputPosition];
	for(int ix = 0; ix < valid.length; ix++){
	    valid[ix] = -1;
	    flipRate[ix] = -1;
	}
	//valid[outputPosition] = outputPostion;
	addRange(valid, flipRate, 0, 15, 0);
	System.out.print("Remove Attribute 4");
	double score = sayu.removeAttribute(5, scoreFunction);
	System.out.println(" has score = " + score);
	valid[4] = 14;
	sayu.commit();
	System.out.println("Commit Score is " + sayu.getScore(Constants.TUNE_SET, scoreFunction));
	int[] array = topIndex(valid);
	System.out.println("invalidate " + sayu.getNumRules() + " " + valid[sayu.getNumRules()] + " -> " + array[1]+ " valid[" + array[1] + "] = " + valid[array[1]]);
	valid[sayu.getNumRules()] = -1;
	doComparison(valid, flipRate, array[1]-1, false);

	System.out.print("Remove Attribute 13");
	score = sayu.removeAttribute(14, scoreFunction);
	System.out.println(" has score = " + score);
	array = topIndex(valid);
	sayu.commit();
	System.out.println("Commit Score is " + sayu.getScore(Constants.TUNE_SET, scoreFunction));
	System.out.println("invalidate " + sayu.getNumRules() + " " + valid[sayu.getNumRules()] + " -> " + array[1]+ " valid[" + array[1] + "] = " + valid[array[1]]);
	valid[sayu.getNumRules()] = -1;

	//
	doComparison(valid, flipRate, array[1]-1, false);

	System.out.print("Remove Attribute 10 & fail");
	score = sayu.removeAttribute(11, scoreFunction);
	System.out.println(" has score = " + score);
	System.out.print("Remove Attribute 9");
	score = sayu.removeAttribute(10, scoreFunction);
	System.out.println(" has score = " + score);
	array = topIndex(valid);
	valid[9] = valid[array[1]];
	sayu.commit();
	System.out.println("Commit Score is " + sayu.getScore(Constants.TUNE_SET, scoreFunction));
	System.out.println("invalidate " + sayu.getNumRules() + " " + valid[sayu.getNumRules()] + " -> " + array[1] + " valid[" + array[1] + "] = " + valid[array[1]]);
	valid[sayu.getNumRules()] = -1;
	doComparison(valid, flipRate, array[1]-1, false);

	addRange(valid, flipRate, 15, 25, 3);

	System.out.print("Remove Attribute 4 (aka 14)");
	score = sayu.removeAttribute(15, scoreFunction);
	System.out.println(" has score = " + score);
	array = topIndex(valid);
	valid[4] = valid[array[1]];
	sayu.commit();
	System.out.println("Commit Score is " + sayu.getScore(Constants.TUNE_SET, scoreFunction));
	System.out.println("invalidate " + sayu.getNumRules() + " " + valid[sayu.getNumRules()] + " -> " + array[1]+ " valid[" + array[1] + "] = " + valid[array[1]]);
	valid[sayu.getNumRules()] = -1;
	doComparison(valid, flipRate,  array[1]-1, false);

	
	addRange(valid, flipRate, 25, outputPosition, 4);
	array = topIndex(valid);
	doComparison(valid, flipRate, array[1]-1, false);
	
    }

    public void addReplaceTest(){
	if (option == 0){
	    System.out.println("NB");
	    sayu = new IncNB(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	}
	else if (option == 1){
	    System.out.println("TAN");
	    sayu = new IncTan(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	}
	else{
	    System.out.println("Invalid Option");
	    System.exit(-1);
	}
	
	//sayu = new FastTan(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	System.out.println("Initial Score " + sayu.getScore(Constants.TUNE_SET, scoreFunction));
	int[] valid = new int[outputPosition];
	int[] flipRate = new int[outputPosition];
	for(int ix = 0; ix < valid.length; ix++){
	    valid[ix] = -1;
	    flipRate[ix] = -1;
	}
	//valid[outputPosition] = outputPostion;
	addRange(valid,flipRate,  0, 15, 0);
	System.out.print("Remove Attribute 4");
	double score = sayu.removeAttribute(5, scoreFunction);
	System.out.println(" has score = " + score);
	valid[4] = 14;
	sayu.commit();
	System.out.println("Commit Score is " + sayu.getScore(Constants.TUNE_SET, scoreFunction));
	int[] array = topIndex(valid);
	System.out.println("invalidate " + sayu.getNumRules() + " " + valid[sayu.getNumRules()] + " -> " + array[1]+ " valid[" + array[1] + "] = " + valid[array[1]]);
	valid[sayu.getNumRules()] = -1;
	doComparison(valid, flipRate, array[1]-1, false);


	System.out.print("Replace Attribute 9");
	flipRate[8] = 5;
	score = replaceAttribute(9, 8, flipRate[8]);
	System.out.println(" has score = " + score);
	array = topIndex(valid);
	sayu.commit();
	System.out.println("Commit Score is " + sayu.getScore(Constants.TUNE_SET, scoreFunction));	
	doComparison(valid, flipRate, array[1]-1, false);
	//System.exit(-1);
	System.out.print("Replace Attribute 13");
	flipRate[13] = 5;
	score = replaceAttribute(14, 13, flipRate[13]);
	System.out.println(" has score = " + score);
	array = topIndex(valid);
	sayu.commit();
	System.out.println("Commit Score is " + sayu.getScore(Constants.TUNE_SET, scoreFunction));	
	doComparison(valid, flipRate, array[1]-1, false);

	addRange(valid, flipRate, 15, 25, 1);

	System.out.print("Replace Attribute 4 (aka 14)");
	flipRate[4] = 5;
	score = replaceAttribute(15, 14, flipRate[4]);
	System.out.println(" has score = " + score);
	array = topIndex(valid);
	sayu.commit();
	System.out.println("Commit Score is " + sayu.getScore(Constants.TUNE_SET, scoreFunction));

	doComparison(valid, flipRate, array[1]-1, false);

	
	addRange(valid, flipRate, 25, outputPosition, 1);
	array = topIndex(valid);
	doComparison(valid, flipRate, array[1]-1, false);
	
    }

    public double replaceAttribute(int sayuIdx, int idx, int flipRate){
	byte[][] trainByte = divide(trainInt, trainPos, outputPosition, idx, flipRate);
	byte[][] tuneByte = divide(tuneInt, tunePos, outputPosition, idx, flipRate);
	byte[][] testByte = divide(testInt, testPos, outputPosition, idx, flipRate);
	double newScore = sayu.replaceAttribute(trainByte[1], trainByte[0], 
						tuneByte[1], tuneByte[0],
						testByte[1], testByte[0], 
						sayuIdx, scoreFunction, 2);
	return newScore;
    }


    public void runSAYUAdd(){//String trainSet, String tuneSet, String testSet){

	if (option == 0){
	    System.out.println("NB");
	    sayu = new IncNB(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	}
	else if (option == 1){
	    System.out.println("TAN");
	    sayu = new IncTan(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	}
	else{
	    System.out.println("Invalid Option");
	    System.exit(-1);
	}
	
	int[] valid = new int[outputPosition];
	int[] flipRate = new int[outputPosition];
	int currIdx = 0;
	for(int ix = 0; ix < valid.length; ix++){
	    valid[ix] = -1;
	    flipRate[ix] = -1;
	}
	
	double bestScore = -1;
	boolean initScore = true;
	for(int ix = 0; ix < outputPosition; ix++){
	    sayu.newHead(0);
	    System.out.println("Evaluating Attribute " + ix);
	    valid[currIdx] = ix;
	   
	    byte[][] trainByte = divide(trainInt, trainPos, outputPosition, ix);
	    byte[][] tuneByte = divide(tuneInt, tunePos, outputPosition, ix);
	    byte[][] testByte = divide(testInt, testPos, outputPosition, ix);

	    double newScore = sayu.addAttribute(trainByte[1], trainByte[0], 
					       tuneByte[1], tuneByte[0],
					       testByte[1], testByte[0], 
					       scoreFunction, 2);
	    boolean scoreImprove = (newScore > bestScore);
	    if (initScore){
		initScore = false;
		scoreImprove = true;
	    }

	    if (scoreImprove){
		System.out.println("Accept Move");
		sayu.commit();
		double score = sayu.getScore(Constants.TUNE_SET, scoreFunction);
		System.out.println("Spec Score " + newScore  + " Commit score = " + score + " " + bestScore);
		bestScore = newScore;

		doComparison(valid, flipRate, ix, false);
		currIdx++;
	    }
	    else if (currIdx > 3){
		System.out.println("Reject Move");
		sayu.commit();
		doComparison(valid, flipRate, ix, false);
		double removeScore = sayu.removeAttribute(ix+1, scoreFunction);
		double sDiff = removeScore - bestScore;
		System.out.println("Best score " + bestScore + " remove score " + removeScore + " newScore " + newScore + " diff = " + sDiff);
		if (Math.abs(sDiff) > 0.00001){
		    System.out.println("ERROR ON REMOVE ");
		    System.exit(-1);
		}
		valid[currIdx] = -1;
		sayu.commit();
	    }
	    System.out.println();
	}
    }

    public void testAllFunctions(){//String trainSet, String tuneSet, String testSet){

	if (option == 0){
	    System.out.println("NB");
	    sayu = new IncNB(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	}
	else if (option == 1){
	    System.out.println("TAN");
	    sayu = new IncTan(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	}
	else{
	    System.out.println("Invalid Option");
	    System.exit(-1);
	}
	
	int[] valid = new int[outputPosition];
	int[] flipRate = new int[outputPosition];
	int currIdx = 0;
	for(int ix = 0; ix < valid.length; ix++){
	    valid[ix] = -1;
	    flipRate[ix] = -1;
	}
	HashMap<Integer,Integer> inNetwork = new HashMap<Integer,Integer>();
	HashSet<Integer> outNetwork = new HashSet<Integer>();
	double bestScore = -1;
	boolean initScore = true;
	int add = 0;
	int remove = 0;
	boolean completedAdd = false;
	for(int ix = 0; ix < outputPosition; ix++){
	    System.out.println("Evaluating Attribute " + ix);
	    sayu.newHead(0);

	    valid[currIdx] = ix;
	   
	    byte[][] trainByte = divide(trainInt, trainPos, outputPosition, ix);
	    byte[][] tuneByte = divide(tuneInt, tunePos, outputPosition, ix);
	    byte[][] testByte = divide(testInt, testPos, outputPosition, ix);

	    double newScore = sayu.addAttribute(trainByte[1], trainByte[0], 
					       tuneByte[1], tuneByte[0],
					       testByte[1], testByte[0], 
					       scoreFunction, 2);
	    boolean scoreImprove = (newScore > bestScore);
	    if (initScore){
		initScore = false;
		scoreImprove = true;
	    }

	    if (scoreImprove){
		completedAdd = true;
		add++;
		sayu.commit();
		System.out.println("Accept Move: Add " + ix + " " + sayu.getNumRules());
		double score = sayu.getScore(Constants.TUNE_SET, scoreFunction);
		//System.out.println("Spec Score " + newScore  + " Commit score = " + score + " " + bestScore);
		bestScore = newScore;

		inNetwork.put(ix, currIdx);
		doComparison(valid, flipRate, ix, false);
		currIdx++;
	    }
	    else if (currIdx > 3){
		outNetwork.add(ix);

		sayu.commit();
		doComparison(valid, flipRate, ix, false);
		double removeScore = sayu.removeAttribute(ix+1, scoreFunction);
		double sDiff = removeScore - bestScore;
		
		if (Math.abs(sDiff) > 0.00001){
		    System.out.println("Reject Move");
		    System.out.println("Best score " + bestScore + " remove score " + removeScore + " newScore " + newScore + " diff = " + sDiff);
		    System.out.println("ERROR ON REMOVE ");
		    System.exit(-1);
		}
		valid[currIdx] = -1;
		sayu.commit();
	    }
	    System.out.println();
	    if (sayu.getNumRules() % 23 == 0 && completedAdd){
		System.out.println("Begin Back Fit");
		backFit(inNetwork, outNetwork, valid, flipRate, currIdx-1);

		System.out.println("End Back Fit");
		System.out.print("Curr Idx = " + currIdx + "->");
		remove = remove + (currIdx - sayu.getNumRules());
		currIdx = sayu.getNumRules();
		System.out.println(currIdx);
		System.out.print("Best Score = " + bestScore + "->");
		bestScore = sayu.getScore(Constants.TUNE_SET, scoreFunction);
		System.out.println(bestScore);
		completedAdd = false;
		System.out.println();
	    }
	    if (sayu.getNumRules() % 19 == 0 && completedAdd){
		completedAdd = false;
		System.out.println("Begin Replace Fit");
		replace(inNetwork, outNetwork, valid, flipRate);

		System.out.println("End Replace Fit");
		System.out.print("Curr Idx = " + currIdx + "->");
		remove = remove + (currIdx - sayu.getNumRules());
		currIdx = sayu.getNumRules();
		System.out.println(currIdx);
		System.out.print("Best Score = " + bestScore + "->");
		bestScore = sayu.getScore(Constants.TUNE_SET, scoreFunction);
		System.out.println(bestScore);
		System.out.println();
	    }
	}
	System.out.println("Best Score " + bestScore);
	System.out.println("Num Rules: " + sayu.getNumRules());
	System.out.println("Add: " + add);
	System.out.println("Remove: " + remove);
	System.out.println("Curr Idx: " + currIdx);
	System.out.println("Sayu Score: " + sayu.getScore(Constants.TUNE_SET, scoreFunction));

	sayu.terminate();
    }

    public void backFit(HashMap<Integer,Integer> in, HashSet<Integer> out, int[] valid, int[] flipRate, int maxIdx){
	int cur = maxIdx;
	double bestScore = sayu.getScore(Constants.TUNE_SET,scoreFunction);
	LinkedList<Integer> removeSet = new LinkedList<Integer>();
	int[] array = new int[in.keySet().size()];
	int ix = 0;
	for(Iterator<Integer> iter = in.keySet().iterator(); iter.hasNext(); ){
	    array[ix] = iter.next();
	    ix++;
	}
	for(ix = 0; ix < array.length; ix++){
	    int pos = array[ix];
	    double removeScore = sayu.removeAttribute(pos+1, scoreFunction);
	    int vidx = in.get(pos);
	    
	    boolean scoreImprove = (removeScore > bestScore);
	    if (scoreImprove){
		sayu.commit();
		System.out.println("Accept Remove: "+ pos + " valid idx " + vidx + " max idx " + maxIdx + " " + valid[maxIdx] + " score " + Utils.round(removeScore, 5) + " " + Utils.round(sayu.getScore(Constants.TUNE_SET, scoreFunction),5));
		bestScore = removeScore;
		removeSet.add(pos);
		valid[vidx] = valid[maxIdx];
		flipRate[vidx] = flipRate[maxIdx];
		in.put(valid[maxIdx], vidx);
		valid[maxIdx] = -1;
		doComparison(valid, flipRate, pos, false);
		maxIdx--;
	    }
	    else{
		System.out.println("Reject Remove: " + pos + " valid idx " + vidx + " maxIdx " + maxIdx + " " + Utils.round(bestScore,5) + " " + Utils.round(removeScore,5) + " " + Utils.round(sayu.getScore(Constants.TUNE_SET, scoreFunction),5));
		valid[vidx] = valid[maxIdx];
		int oldFlip = flipRate[vidx];
		flipRate[vidx] = flipRate[maxIdx];
		int tmpIdx = valid[maxIdx];
		int tmpFlip = flipRate[maxIdx];
		valid[maxIdx] = -1;
		flipRate[maxIdx] = -1;
		int[][] c = compressValid(valid, flipRate);
		scoreCompare(c[0], c[1], removeScore);
		valid[vidx] = pos;
		valid[maxIdx] = tmpIdx;
		flipRate[vidx] = oldFlip;
		flipRate[maxIdx] = tmpFlip;
	    }
	}
	while(removeSet.size() > 0){
	    int rm = removeSet.removeFirst();
	    in.remove(rm);
	    out.add(rm);
	}
    }

    public void replace(HashMap<Integer,Integer> in, HashSet<Integer> out, int[] valid, int[] flipRate){
	double bestScore = sayu.getScore(Constants.TUNE_SET,scoreFunction);

	int[] array = new int[in.keySet().size()];
	int ix = 0;
	for(Iterator<Integer> iter = in.keySet().iterator(); iter.hasNext(); ){
	    array[ix] = iter.next();
	    ix++;
	}
	for(ix = 0; ix < array.length; ix++){
	    int pos = array[ix];
	    int vidx = in.get(pos);
	    double replaceScore =  replaceAttribute(pos+1, pos, 5);
	    boolean scoreImprove = (replaceScore > bestScore);
	    if (scoreImprove){
		sayu.commit();
		flipRate[vidx] = 5;
		double score = sayu.getScore(Constants.TUNE_SET, scoreFunction);
		System.out.print("Accept Replace: "+ pos + " valid idx " + vidx + " " + flipRate[vidx] + " ");
		System.out.println(Utils.round(replaceScore,5) + " " +
				   Utils.round(score,5));
		bestScore = replaceScore;
		doComparison(valid, flipRate, pos, false);
	    }
	    else{
		System.out.println("Reject Replace: " + pos + " valid idx " + vidx  + " " + Utils.round(bestScore,5) + " " + Utils.round(replaceScore,5) + " " + Utils.round(sayu.getScore(Constants.TUNE_SET, scoreFunction),5));
		int oldFlip = flipRate[vidx];
		flipRate[vidx] = 5;
		scoreCompare(valid, flipRate, replaceScore);
		flipRate[vidx] = oldFlip;
	    }
	}
    }//end replace()

   
    public void addAll(){
	if (option == 0){
	    sayu = new IncNB(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	}
	else if (option == 1){
	    sayu = new IncTan(trainPos, trainNeg, tunePos, tuneNeg, testPos, testNeg);
	}
	else{
	    System.out.println("Invalid Option");
	    System.exit(-1);
	}

	int[] valid = new int[outputPosition];
	int[] flipRate = new int[outputPosition];
	for(int ix = 0; ix < valid.length; ix++){
	    valid[ix] = -1;
	    flipRate[ix] = -1;
	}
	//valid[outputPosition] = outputPostion;
	addRange(valid, flipRate, 0, outputPosition, 0);
    }


    private void addRange(int[] valid, int[] flipRate, int start, int end, int offset){
	System.out.println("Init Add: " + (start-offset));
	for(int ix = start; ix < end; ix++){
	    sayu.newHead(0);
	    valid[ix-offset] = ix;
	    byte[][] trainByte = divide(trainInt, trainPos, outputPosition, ix);
	    byte[][] tuneByte = divide(tuneInt, tunePos, outputPosition, ix);
	    byte[][] testByte = divide(testInt, testPos, outputPosition, ix);
	    double score = sayu.addAttribute(trainByte[1], trainByte[0], 
					    tuneByte[1], tuneByte[0],
					    testByte[1], testByte[0], 
					    scoreFunction, 2);
	    System.out.print("Evaluating Attribute " + ix);
	    System.out.print(" has score = " + Utils.round(score,5));
	    sayu.commit();
	    score = sayu.getScore(Constants.TUNE_SET, scoreFunction);
	    System.out.println(" commit score = " + Utils.round(score,5));
	    doComparison(valid, flipRate, ix, false);
	}
    }

    /**

     */
    public static int[][] buildNB(int size, int out){
	int[][] graph = new int[size][size];
	for(int ix = 0; ix < size-1; ix++){
	    for(int jx = (ix+1); jx < size; jx++){
		graph[ix][jx] = Constants.NO_EDGE;
		graph[jx][ix] = Constants.NO_EDGE;
	    }
	    if (ix != out){
		graph[ix][out] = Constants.IN_EDGE;
		graph[out][ix] = Constants.OUT_EDGE;
	    }
	}
	return graph;
    }

    private int[][] compressValid(int[] valid, int[] flip){
	int[][] rt = new int[2][valid.length];
	
	for(int ix = 0; ix < valid.length; ix++){
	    rt[0][ix] = -1;
	    rt[1][ix] = -1;
	}
	int pos = 0;
	for(int ix = 0; ix < valid.length; ix++){
	    if (valid[ix] >= 0){
		rt[0][pos] = valid[ix];
		rt[1][pos] = flip[ix];
		pos++;
	    }
	}

	return rt;
    }


    public void scoreCompare(int[] valid, int[] flipRate, double sayuScore){
	int[][] newTrain = getNewDataSet(trainInt, valid, flipRate, outputPosition);
	int[][] newTune = getNewDataSet(tuneInt, valid, flipRate, outputPosition);
	int[][] newTest = getNewDataSet(testInt, valid, flipRate, outputPosition);
	int newOut = newTrain[0].length-1;
	Edge[] pickedEdge = new Edge[newOut];
	VariableConsecInt[] newAttrib = new VariableConsecInt[newOut+1];
	System.arraycopy(attributes, 0, newAttrib, 0, newOut);
	newAttrib[newOut] = attributes[outputPosition];
	int[][] g1  = null;
	if (option == 0){
	    g1 = buildNB(newTrain[0].length, newOut);
	}
	else if (option == 1){
	    g1 = MaxTan.maxTanGraph(newTrain, newOut, newAttrib, pickedEdge); 
	}
	CondProb[] cpts  = MaxTan.buildCPTs(g1, newAttrib, newTrain, newOut);
	double[] probs = MaxTan.getProbs(newTune, cpts);	
	double[] area = ScoreFunctions.calcPRArea(probs, cats[1], tunePos, tuneNeg);
	
	double diffArea = (area[1] - sayuScore);
	if ((Math.abs(diffArea) > 0.0001)){
	    System.out.print("Scracth PR Area = " + area[1] + " SAYU " + sayuScore);
	    System.out.println(" diff area: " + diffArea);
	    System.out.println("ERROR ERROR ERROR");
	    System.exit(-1);
	}
    }

    public void doComparison(int[] valid, int[] flipRate, int ix, boolean printGraphs){
	
	int[][] newTrain = getNewDataSet(trainInt, valid, flipRate, outputPosition);
	int[][] newTune = getNewDataSet(tuneInt, valid, flipRate, outputPosition);
	int[][] newTest = getNewDataSet(testInt, valid, flipRate, outputPosition);
	int newOut = newTrain[0].length-1;

	Edge[] pickedEdge = new Edge[newOut];
	VariableConsecInt[] newAttrib = new VariableConsecInt[newOut+1];
	System.arraycopy(attributes, 0, newAttrib, 0, newOut);
	newAttrib[newOut] = attributes[outputPosition];
	int[][] g1 = null; 
	if (option == 0){
	    g1 = buildNB(newTrain[0].length, newOut);
	}
	else if (option == 1){
	    g1 = MaxTan.maxTanGraph(newTrain, newOut, newAttrib, pickedEdge); 
	}
	CondProb[] cpts  = MaxTan.buildCPTs(g1, newAttrib, newTrain, newOut);
	double[] incProbs = sayu.getProbs(Constants.TRAIN_SET);
	double[] scratchProbs = MaxTan.getProbs(newTrain, cpts);
	double[] probs = MaxTan.getProbs(newTune, cpts);	
	double[] incTune = sayu.getProbs(Constants.TUNE_SET);
	
	int[][] g2 = sayu.getGraph();
	if (printGraphs){
	  System.out.println("Original TAN Graph");
	  printGraph(g1, g1.length-1);
	  System.out.println("");
	  System.out.println("Incremental TAN Graph");
	  printGraph(g2, g1.length-1);
	}
	boolean same = compareGraphs(g1, g2, "Original TAN", "Inc TAN");
	int diffProbs = compareProbs(incProbs, scratchProbs);
	double[] area = ScoreFunctions.calcPRArea(probs, cats[1], tunePos, tuneNeg);
	double diffArea = (area[1] - sayu.getScore(Constants.TUNE_SET, Constants.PR_AREA));
	if ((Math.abs(diffArea) > 0.0001) || 
	    diffProbs > 0){
	    System.out.println("Attribute " + ix + " w/same = " + same);
	    System.out.println("Different probs: " +  diffProbs);
	    System.out.print("Scracth PR Area = " + area[1]);
	    System.out.println(" diff area: " + diffArea);
	    System.out.println("ERROR ERROR ERROR");
	    System.exit(-1);
	}

    }
    private int[] topIndex(int[] valid){
	int[] array = new int[2];
	array[0] = valid[0];
	array[1] = 0;
	//array[2] = 0;
	boolean seenNeg1 = false;
	for(int ix = 1; ix < valid.length; ix++){
	    if (valid[ix] >= 0 && seenNeg1){
		System.out.println("ERROR");
	    }
	    else if (valid[ix] >= 0){
		if (array[0] < valid[ix]){
		    array[0] = valid[ix];
		}
		array[1] = ix;
	    }
	    if (valid[ix] == -1){
		seenNeg1 = true;
	    }
	}   
	return array;
    }



    /**
       Methods for loading data
     */

 
    /**
       This method reads in a dataset. It is assumed that the data is
       stored as integers or only contains discrete attributes. It
       stores the data in integer arrays in a linkedlist

       @param fileName the name of the file containing data set
       @param sep is the seperator between the attributes in the
       feature vectors
 
    */
    public int[][] readDataFileInt(String fileName, String sep){
	try{
	    RandomAccessFile infile = new RandomAccessFile(fileName, "r");
	    String[] split;
	    String line = infile.readLine();
	    int count = 1;
	    LinkedList<int[]> exs = new LinkedList<int[]>();
	    while(line != null){	       
		split = line.split(sep);
		int[] tmp = new int[split.length];
		for(int ix = 0; ix < split.length; ix++){
		    tmp[ix] = Integer.parseInt(split[ix]);
		}//end of for loop
		line = infile.readLine();
		exs.add(tmp);
		count++;
	    }
	    return convertListIntsOrder(exs);
	}//end try block
	catch(IOException exc){
	    System.out.println(exc.toString());
	    return null;
	}
    }//end of method 
    /**
       Converts the initial list of feature vectors into an array

       @param list a list of DataElement feature vectors
       @return an array of DataElement feature vectors
    */
    public int[][] convertListInts(LinkedList<int[]> list){
	int len = list.size();
	int[][] examples = new int[len][];
	for(int ix = 0; ix < len; ix++){
	    examples[ix] = list.removeFirst();
	}
	return examples;
    }//end method convertListInts

    /**
       Converts the initial list of feature vectors into an array

       @param list a list of DataElement feature vectors
       @return an array of DataElement feature vectors
    */
    public int[][] convertListIntsOrder(LinkedList<int[]> list){
	int len = list.size();
	int[][] examples = new int[len][];
	for(int ix = 0; ix < len; ix++){
	    examples[ix] = list.removeFirst();
	}
	int[][] order = new int[len][];
	int index =0;
	int out = examples[0].length-1;
	for(int ix = 0; ix < examples.length; ix++){
	    if (examples[ix][out] == 1){
		order[index] = examples[ix];
		index++;
	    }
	}

	for(int ix = 0; ix < examples.length; ix++){
	    if (examples[ix][out] == 0){
		order[index] = examples[ix];
		index++;
	    }
	}
	return order;
    }//end method convertListInts

    /**
       Methods for manipulating data
     */

    public static byte[][] divide(int[][] tmp, int posCount, int output, int rule){
        byte[][] tmp2 = new byte[2][];
        tmp2[1] = new byte[posCount];
        tmp2[0] = new byte[tmp.length-posCount];
        int cat0Pos = 0;
        int cat1Pos = 0;
        for(int ix = 0; ix < tmp.length; ix++){
            if (tmp[ix][output] == 1){
                tmp2[1][cat1Pos] = (byte)tmp[ix][rule]; 
                cat1Pos++;
            }
            else{
                tmp2[0][cat0Pos] = (byte)tmp[ix][rule]; 
                cat0Pos++;
            }
        }
        return tmp2;
    }
    /**
       Methods for manipulating data
     */
    public static byte[][] divide(int[][] tmp, int posCount, int output, int rule, int flipRate){
        byte[][] tmp2 = new byte[2][];
        tmp2[1] = new byte[posCount];
        tmp2[0] = new byte[tmp.length-posCount];
        int cat0Pos = 0;
        int cat1Pos = 0;
        for(int ix = 0; ix < tmp.length; ix++){
	    byte val = ((ix+1) % flipRate == 0) ? (byte) 1 : (byte)tmp[ix][rule]; 
            if (tmp[ix][output] == 1){
                tmp2[1][cat1Pos] = val;
                cat1Pos++;
            }
            else{
                tmp2[0][cat0Pos] = val;
                cat0Pos++;
            }
        }
        return tmp2;
    }



   /**
       @param data
       @param valid
       @param outputPos
     */
    public int[][] getNewDataSet(int[][] data, int[] valid, int[] flipRate, int outputPos){
	int len = 0;
	for(int ix = 0; ix < valid.length; ix++){
	    if (valid[ix] >=0){
		len++;
	    }
	}
        int[][] newData = new int[data.length][len+1];
	
        for(int ix = 0; ix < data.length; ix++){
	    int pos = 0;
            for(int jx = 0; jx < data[ix].length-1; jx++){
		int index = valid[jx];
		if ((index >= 0) && (index != outputPos)){
		    int val = data[ix][index];
		    if (flipRate[jx] > 0 && 
			((ix+1) % flipRate[jx] == 0)){
			val = 1;
		    }
		    newData[ix][pos] = val;//data[ix][index];
		    
		    pos++;
		}
            }
            newData[ix][newData[ix].length-1] = data[ix][outputPos];
        }
        return newData;
    }



    /*
      Evaluation
     */

    public static int compareProbs(double[] p1, double[] p2){
	int cnt = 0;
	for(int ix = 0; ix < p1.length; ix++){	  
	    double diff = Math.abs(p1[ix] - p2[ix]); 
	    if (diff > 0.00001){
		if (cnt == 0){
		    System.out.println("Diff " + p1[ix] + " " + p2[ix] + " = " + diff + " ix " + ix);		   
		}
		cnt++;
	    }
	}
	return cnt;
    }
    public boolean compareGraphs(int[][] g1, int[][] g2, String n1, String n2){
        boolean same = true;
        for(int ix = 0; ix < (g1.length-2); ix++){
            for(int jx = (ix+1); jx < (g1.length-1); jx++){
                if (g1[ix][jx] != g2[ix][jx]){
                    same = false;
                    if (g1[ix][jx] == Constants.NO_EDGE){
                        System.out.println(n1 + " graph is missing an edge " + ix + " " + jx);
                    }
                    else if (g2[ix][jx] == Constants.NO_EDGE){
                        System.out.println(n2 + " graph is missing an edge "+ ix + " " + jx );
                    }
		    else{
			System.out.println("flipped edge "+ ix + " " + jx );
		    }
                }
            }
        }//end ix loop
        return same;
    }//end method compareGraphs

    
    public static void printGraph(int[][] g1, int len){
	for(int jx = 0; jx < len; jx++){
	    for(int kx = 0; kx < len; kx++){
		System.out.print(g1[jx][kx] + " ");
	    }
	    System.out.println();
	}
    }

}