package sayu;
import java.util.*;

public class FPRComparator implements Comparator{

    /**
       Peforms a comparision based on FPR.
       @param o is of type ROCPoint
       @return -1 if this.getFPR() < o.getFPR(). 0 if o.getFPR() == this.getFPR(). 1 if this.getFPR() > o.getFPR()

     */
    public int compare(Object o1, Object o2){
        ROCPoint tmp1 = (ROCPoint)o1;
        ROCPoint tmp2 = (ROCPoint)o2;
        double fpr1 = tmp1.getFPR();
        double fpr2 = tmp2.getFPR();
        if (fpr1 < fpr2){
            return -1;
        }
        else if (fpr1 > fpr2){
            return 1;
        }
        else{
            double tpr1 = tmp1.getTPR();
            double tpr2 = tmp2.getTPR();
            if (tpr1 < tpr2){
                return -1;
            }
            else if (tpr1 > tpr2){
                return 1;
            }
            else{
                return 0;
            }
        }
    }

}
